/*Read in a text mesh file and output as binary in the "same format"
Format:
Number of verticies: 2 bytes
Vertex information: 12 bytes*Number of verticies - Each vertex consists of 3 floats defining x, y, and z position
Number of polygons: 2 bytes
Polygon information: 6 bytes*Number of polygons - Each polygon consists of 3 WORD indexes pointing to a polygon corner's vertex
*/

#define DWORD unsigned long
#define WORD unsigned short
#include <string.h> //strlen, strcpy, strtok
#include <stdlib.h> //atof, atoi
#include <iostream.h> //cin, cout
#include <stdio.h> //fopen

void main()
{
	//Get in the file name
	char TheData[255]; //Buffer
	cout << "FileName (without .x):";
	cout.flush();
	cin.getline(TheData, 255);

	//Add .x to end of file and open
	DWORD StrLen=strlen(TheData);
	strcpy(TheData+StrLen, ".x");
	FILE* InFile=fopen(TheData, "r");
	if(!InFile)
	{
		cout << "File not found" << endl;
		return;
	}
	

	//Add .b3d to end of filename and open for writing
	strcpy(TheData+StrLen, ".b3d");
	FILE* OutFile=fopen(TheData, "wb");
	cout << "Writing out to: " << TheData << endl;

	//Read/write number of verticies
	fgets(TheData, 255, InFile);
	WORD NumItems=atoi(TheData);
	fwrite((char*)&NumItems, sizeof(NumItems),1,OutFile);
	cout << NumItems << " verticies" << endl;

	//Read/write vertex information
	for(WORD i=0;i<NumItems;i++)
	{
		fgets(TheData, 255, InFile);
		//Each vertex has 3 floats separated by semicolons
		char *TokNum=strtok(TheData, (const char*)";");
		for(WORD p=0;p<3;p++)
		{
			float TheFloat=atof(TokNum);
			fwrite((char*)&TheFloat, sizeof(TheFloat),1,OutFile);
			TokNum=strtok(NULL, (const char*)";");
		}
	}

	//Skip blank lines and read/write number of polygons
	do
	{
		fgets(TheData, 255, InFile);
		NumItems=atoi(TheData);
	} while(!NumItems);
	fwrite((char*)&NumItems, sizeof(NumItems),1,OutFile);
	cout << NumItems << " polygons" << endl;


	//Read/write polygon information
	for(i=0;i<NumItems;i++)
	{
		fgets(TheData, 255, InFile);
		//Each vertex has "3;" followed by 3 WORDS separated by semicolons
		char *TokNum=strtok(TheData, (const char*)";");
		TokNum=strtok(NULL, (const char*)",");
		for(WORD p=0;p<3;p++)
		{
			WORD TheNum=atoi(TokNum);
			fwrite((char*)&TheNum, sizeof(TheNum),1,OutFile);
			TokNum=strtok(NULL, (const char*)",");
		}
	}

	//Close files
	fclose(InFile);
	fclose(OutFile);
	cout << "Parsing complete" << endl;
}