//Calculates FPS using an average over the last 2 seconds
#ifndef _FPS_H
#define _FPS_H

typedef unsigned long DWORD;

class FPS
{
	public:
		FPS();										//Constructor
		~FPS();										//Destructor
		void AddFrame();							//Adds a frame to the count - Call when a new frame has been drawn
		void ResetFrames();							//Reset fps system
		DWORD GetTotalFrames();						//Get the total number of frames the program has drawn since the beginning
		float GetFps();								//Returns the current average FPS as a float
		char* GetFpsString(int NumberOfDecimals);	//Returns the current average FPS as a string with provided precision - Returned strings are deleted upon next FPS string retrieval

		//Inlined functions
		inline operator float() { return GetFps(); }
		inline operator DWORD()	{ return (DWORD)GetFps(); }
		inline operator int()	{ return (int)GetFps(); }
		inline operator char*() { return GetFpsString(0); }

		//Variables
	private:
		char *LastFpsStringPointer;	//Pointer to the last fps string to clear the memory
		DWORD TotalFrames;			//Count of frames from the beginning
		DWORD StoreTicks;			//Time of last "second long boundary" taken (<1 second ago)
		DWORD OldTicks;				//Time of previous "second long boundary" before StoreTicks (1-2 seconds ago)
		DWORD FrameOn;				//Frames counted in last 2 seconds
		DWORD LastTotalFrames;		//Frames counted in last second
};
#endif
